#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: generate_vserver_list.pl, v1.1.0.0 Sun 04 May 2008 12:06:05 AM EST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.

# This constructor / handler uses 'vzlist' to poll extended vserver status.
# Additionally it parses the vserver config files in /etc/sysconfig/vz-scripts/
# The information is then written off into CCE for GUI usage. 

$whatami = "constructor";

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Location of the vzlist-dump:
$vzlistdump = '/tmp/vserver-list';

# Location of vserver config files (directory - with trailing slash):
$vzcfgdir = '/etc/sysconfig/vz-scripts/';

# We are starting sane:
$bad_info_detected = '0';

# Parse existing VPS and shove their data into CCE:
&main;

# If we detect bad info, we will try again. Up to three times.
# Then we give up as something is barfed up badly.
if ($bad_info_detected < '3') {
    &main;
}
else {
    exit 1;
}

# CCE'ize example VPS config files:
&sampleconfigs;

# CCE'ize existing OS-Templates:
&ostemplates;

exit 0;

##
# Subs:
##

sub main {

    # Generate vzlist-dump:
    #system("vzlist -a -o vpsid,ip,hostname,status,numproc,kmemsize,kmemsize.m,kmemsize.b,kmemsize.l,kmemsize.f,lockedpages,lockedpages.m,lockedpages.b,lockedpages.l,lockedpages.f,privvmpages,privvmpages.m,privvmpages.b,privvmpages.l,privvmpages.f,shmpages,shmpages.m,shmpages.b,shmpages.l,shmpages.f,numproc,numproc.m,numproc.b,numproc.l,numproc.f,physpages,physpages.m,physpages.b,physpages.l,physpages.f,vmguarpages,vmguarpages.m,vmguarpages.b,vmguarpages.l,vmguarpages.f,oomguarpages,oomguarpages.m,oomguarpages.b,oomguarpages.l,oomguarpages.f,numtcpsock,numtcpsock.m,numtcpsock.b,numtcpsock.l,numtcpsock.f,numflock,numflock.m,numflock.b,numflock.l,numflock.f,numpty,numpty.m,numpty.b,numpty.l,numpty.f,numsiginfo,numsiginfo.m,numsiginfo.b,numsiginfo.l,numsiginfo.f,tcpsndbuf,tcpsndbuf.m,tcpsndbuf.b,tcpsndbuf.l,tcpsndbuf.f,tcprcvbuf,tcprcvbuf.m,tcprcvbuf.b,tcprcvbuf.l,tcprcvbuf.f,othersockbuf,othersockbuf.m,othersockbuf.b,othersockbuf.l,othersockbuf.f,dgramrcvbuf,dgramrcvbuf.m,dgramrcvbuf.b,dgramrcvbuf.l,dgramrcvbuf.f,numothersock,numothersock.m,numothersock.b,numothersock.l,numothersock.f,dcachesize,dcachesize.m,dcachesize.b,dcachesize.l,dcachesize.f,numfile,numfile.m,numfile.b,numfile.l,numfile.f,numiptent,numiptent.m,numiptent.b,numiptent.l,numiptent.f,diskspace,diskspace.s,diskspace.h,diskinodes,diskinodes.s,diskinodes.h,laverage,cpulimit,cpuunits | sed 's/^[ \t]*//;s/[ \t]*\$//' | sed 's/-/0/'g > $vzlistdump");
    system("vzlist -a -o vpsid,ip,hostname,status,numproc,kmemsize,kmemsize.m,kmemsize.b,kmemsize.l,kmemsize.f,lockedpages,lockedpages.m,lockedpages.b,lockedpages.l,lockedpages.f,privvmpages,privvmpages.m,privvmpages.b,privvmpages.l,privvmpages.f,shmpages,shmpages.m,shmpages.b,shmpages.l,shmpages.f,numproc,numproc.m,numproc.b,numproc.l,numproc.f,physpages,physpages.m,physpages.b,physpages.l,physpages.f,vmguarpages,vmguarpages.m,vmguarpages.b,vmguarpages.l,vmguarpages.f,oomguarpages,oomguarpages.m,oomguarpages.b,oomguarpages.l,oomguarpages.f,numtcpsock,numtcpsock.m,numtcpsock.b,numtcpsock.l,numtcpsock.f,numflock,numflock.m,numflock.b,numflock.l,numflock.f,numpty,numpty.m,numpty.b,numpty.l,numpty.f,numsiginfo,numsiginfo.m,numsiginfo.b,numsiginfo.l,numsiginfo.f,tcpsndbuf,tcpsndbuf.m,tcpsndbuf.b,tcpsndbuf.l,tcpsndbuf.f,tcprcvbuf,tcprcvbuf.m,tcprcvbuf.b,tcprcvbuf.l,tcprcvbuf.f,othersockbuf,othersockbuf.m,othersockbuf.b,othersockbuf.l,othersockbuf.f,dgramrcvbuf,dgramrcvbuf.m,dgramrcvbuf.b,dgramrcvbuf.l,dgramrcvbuf.f,numothersock,numothersock.m,numothersock.b,numothersock.l,numothersock.f,dcachesize,dcachesize.m,dcachesize.b,dcachesize.l,dcachesize.f,numfile,numfile.m,numfile.b,numfile.l,numfile.f,numiptent,numiptent.m,numiptent.b,numiptent.l,numiptent.f,diskspace,diskspace.s,diskspace.h,diskinodes,diskinodes.s,diskinodes.h,laverage,cpulimit,cpuunits | sed 's/^[ \t]*//;s/[ \t]*\$//' > $vzlistdump");

    # Pull the vzlist-dump into a Matrix:
    #
    # I LOVE matrix stuff! If there is a sledload of data to parse, 
    # then there is hardly a more efficient way to do so.
    # A legend of what colums the matrix has is at the end of the code.

    open (F, $vzlistdump) || die "Could not open $vzlistdump: $!";
    $a = 0; 				# Matrix line number, whereas 0 is the first (useable) line of the vzlist dump
    while ($line = <F>) {
	chomp($line);
	next if $line =~ /^\s*$/; 		# skip blank lines
	if ($line =~ /^([A-Za-z]\w*)/) {
            #$matrix_name = $1;
            $matrix_name = 'VPSID';
        } 
        else {
            my (@row) = split (/\s+/, $line);
            push (@{$matrix_name}, \@row); 
        }
        if ($VPSID[$a][0]) { 		# Plausibility check. We will not store anything into CCE if 'vpsid' is not set.
    	    $currentvpsid = $VPSID[$a][0];
	    &readconfig;			# Read missing info from vz config files
	    if ($whatami ne "handler") {
    		# We only run an update of the IP address allocation if we're a constructor:
		&ip_alloc;
	    }
	    &feedthemonster;		# Feed info into CCE
	    if ($new_vps_found == '1') {
		&feedthemonster;		# We found a new VPS. We need to feed the monster again!
	    }
	}
	$a++;
    }
    close(F);
    system("rm $vzlistdump");

    ##
    # Get info about the current CPU utilization and the power of the node:
    ##

    # Location of the vzcpu-dump:
    $vzcpudump = '/tmp/vserver-cpuinfo';

    # Generate vzcpu-dump:
    system("vzcpucheck | sed 's/^[ \t]*//;s/[ \t]*\$//' > $vzcpudump");

    if (-e $vzcpudump) {
	$b = 0;
	open(CPUDUMP,"$vzcpudump") || die("Could not find $vzcpudump. $!");
	while ($line = <CPUDUMP>) {
    	    chomp($line);
    	    next if $line =~ /^\s*$/; # skip blank lines
    	    if (($line =~ /^Current CPU utilization: (.*)/) && ($b == 0)) {
        	$CURRENT_CPU = $1;
    	    }
    	    if (($line =~ /^Power of the node: (.*)/) && ($b == 1)) {
        	$NODE_CPU = $1;
    	    }
    	    $b++;
	}
	close(CPUDUMP);
	system("rm $vzcpudump");
	&cce_update_cpu; # Write the info into CCE
    }
}

# There are a few options in config files that vzlist doesn't provide.
# So we need to read them from the respective config files in
# /etc/sysconfig/vz-scripts/*.conf

sub readconfig {
    # Does the config file exist?
    $cfile = "$vzcfgdir$VPSID[$a][0].conf";
    if (-e $cfile) {
    	open(CFILE,"$cfile") || die("Could not find $cfile. $!");
    	while ($line = <CFILE>) {
    	    chomp($line);
    	    next if $line =~ /^\s*$/; # skip blank lines

    	    if ($line =~ /^ONBOOT=\"([A-Za-z]\w*)\"/) {
    		$onboot = $1;
		if (($onboot eq 'yes') || ($onboot eq 'Yes')) {
    		    $VPSID[$currentvpsid][114] = 'Yes';
		}
		else {
    		    $VPSID[$currentvpsid][114] = 'No';
		}
	    }
    	    if ($line =~ /^CPUUNITS=\"(.*)\"/) {
    		$VPSID[$currentvpsid][113] = $1;
	    }
	    if ($line =~ /^VE_ROOT=\"(.*)\"/) {
		$VPSID[$currentvpsid][115] = $1;
	    }
    	    if ($line =~ /^VE_PRIVATE=\"(.*)\"/) {
        	$VPSID[$currentvpsid][116] = $1;
    	    }
    	    if ($line =~ /^OSTEMPLATE=\"(.*)\"/) {
        	$VPSID[$currentvpsid][117] = $1;
	    }
    	    if ($line =~ /^ORIGIN_SAMPLE=\"(.*)\"/) {
        	$VPSID[$currentvpsid][118] = $1;
	    }
            if ($line =~ /^NAMESERVER=\"(.*)\"/) {
                $nameservers = $1;
                $nameservers =~ s/ /&/g;
                $VPSID[$currentvpsid][119] = "&" . $nameservers . "&";
            }
	    if ($line =~ /^QUOTATIME=\"(.*)\"/) {
    	    	$VPSID[$currentvpsid][120] = $1;
    	    }
	    $quota = '';
	    if ($line =~ /^DISK_QUOTA=\"(.*)\"/) {
		$quota = $1;
		if (($quota eq 'yes') || ($quota eq 'Yes')) {
    	    	    $VPSID[$currentvpsid][121] = 'Yes';
		}
		else {
    	    	    $VPSID[$currentvpsid][121] = 'No';
		}
    	    }
	    if (($line =~ /^DISK_QUOTA=(.*)/) && ($quota eq '')){
		$quota = $1;
		if (($quota eq 'yes') || ($quota eq 'Yes')) {
    	    	    $VPSID[$currentvpsid][121] = 'Yes';
		}
		else {
    	    	    $VPSID[$currentvpsid][121] = 'No';
		}
    	    }

	    if ($line =~ /^QUOTAUGIDLIMIT=\"(.*)\"/) {
    	    	$VPSID[$currentvpsid][122] = $1;
    	    }
	    if ($line =~ /^AVNUMPROC=\"(.*):(.*)\"/) {
    	    	$VPSID[$currentvpsid][123] = $1;
    	    	$VPSID[$currentvpsid][124] = $2;
    	    }

	    # ip_list:
	    if ($line =~ /^IP_ADDRESS=\"(.*)\"/) {
                $ip_list = $1;
                $ip_list =~ s/ /&/g;
		$combined_ip_list = "&" . $ip_list . "&";
		@raw_ip_list =  split('&', $combined_ip_list);
		shift(@raw_ip_list);
		shift(@raw_ip_list);
		$extra_ip_list = join("&", @raw_ip_list);
		if ($extra_ip_list) {
	                $VPSID[$currentvpsid][125] = "&" . $extra_ip_list . "&";
		}
	    }
	}
    }
    close(CFILE);

    # NAMESERVER must be of format 'ipAddr', but on new VPS's it may not be set - yet. If it is
    # NOT set, we set it to '127.0.0.1' here:
    if (!$VPSID[$currentvpsid][119]) {
        $VPSID[$currentvpsid][119] = "127.0.0.1";
    }
    # QUOTATIME may not be set. If it's not set, we set it to zero:
    if (!$VPSID[$currentvpsid][120]) {
        $VPSID[$currentvpsid][120] = "0";
    }
    # DISK_QUOTA may not be set. Valid entries are "yes" or "no". If it's neither, we default to "no":
    if (($VPSID[$currentvpsid][121] ne "Yes") && ($VPSID[$currentvpsid][121] ne "No")) {
        $VPSID[$currentvpsid][121] = "No";
    }
    # QUOTAUGIDLIMIT may not be set. This is for second level quota (user and group disk quota inside the VPS)
    if (!$VPSID[$currentvpsid][122]) {
        $VPSID[$currentvpsid][122] = "10000";
    }
}

# Subroutine that feeds the data into CCE:
sub feedthemonster {
	&validate;
	# This is where we actually populate CCE with the gathered info:
        @oids = $cce->find('Vserver', {'vpsid' => $currentvpsid});
        if ($#oids < 0) {
                #print "Object not yet in CCE. Creating new one.\n";
                ($ok) = $cce->create('Vserver', {
                'vpsid' => $VPSID[$a][0],
                'ip' => $VPSID[$a][1],
                'hostname' => $VPSID[$a][2],
                'timestamp' => time()
                });
		$new_vps_found = '1'; 			# We found a new VPS, one that we have never seen before and which
							# is not yet in CCE. We do not want to risk to populate CCE with ALL
							# the found new data in one go. So let us just set the most basic info
							# and the timestamp. 
							#
							# We also set $new_vps_found = '1' to run feedthemonster() again.
        }
        else {
	        #print "Object already present in CCE. Updating it.\n";
                # find the system object
		$new_vps_found = '0';
		&validate;
                ($sys_oid) = $cce->find('Vserver', {'vpsid' => $currentvpsid});
                ($ok, $sys) = $cce->get($sys_oid);
		
		# For debugging and logging purpose we do not write all 122 entries into CCE in one go. Instead we break it down
		# into multiple blocks so that we can troubleshoot /var/log/messages easily for data-blocks with values that CCE
		# did not like. 
		
                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'vpsid' => $VPSID[$a][0],
                'ip' => $VPSID[$a][1],
                'ip_list' => $VPSID[$a][125],
                'hostname' => $VPSID[$a][2],
                'status' => $VPSID[$a][3],
                'avnumproc_b' => $VPSID[$currentvpsid][123],
                'avnumproc_l' => $VPSID[$currentvpsid][124],
                'kmemsize' => $VPSID[$a][5],
                'kmemsize_m' => $VPSID[$a][6],
                'kmemsize_b' => $VPSID[$a][7],
                'kmemsize_l' => $VPSID[$a][8],
                'kmemsize_f' => $VPSID[$a][9],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'lockedpages' => $VPSID[$a][10],
                'lockedpages_m' => $VPSID[$a][11],
                'lockedpages_b' => $VPSID[$a][12],
                'lockedpages_l' => $VPSID[$a][13],
                'lockedpages_f' => $VPSID[$a][14],
                'privvmpages' => $VPSID[$a][15],
                'privvmpages_m' => $VPSID[$a][16],
                'privvmpages_b' => $VPSID[$a][17],
                'privvmpages_l' => $VPSID[$a][18],
                'privvmpages_f' => $VPSID[$a][19],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'shmpages' => $VPSID[$a][20],
                'shmpages_m' => $VPSID[$a][21],
                'shmpages_b' => $VPSID[$a][22],
                'shmpages_l' => $VPSID[$a][23],
                'shmpages_f' => $VPSID[$a][24],
                'numproc' => $VPSID[$a][25],
                'numproc_m' => $VPSID[$a][26],
                'numproc_b' => $VPSID[$a][27],
                'numproc_l' => $VPSID[$a][28],
                'numproc_f' => $VPSID[$a][29],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'physpages' => $VPSID[$a][30],
                'physpages_m' => $VPSID[$a][31],
                'physpages_b' => $VPSID[$a][32],
                'physpages_l' => $VPSID[$a][33],
                'physpages_f' => $VPSID[$a][34],
                'vmguarpages' => $VPSID[$a][35],
                'vmguarpages_m' => $VPSID[$a][36],
                'vmguarpages_b' => $VPSID[$a][37],
                'vmguarpages_l' => $VPSID[$a][38],
                'vmguarpages_f' => $VPSID[$a][39],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'oomguarpages' => $VPSID[$a][40],
                'oomguarpages_m' => $VPSID[$a][41],
                'oomguarpages_b' => $VPSID[$a][42],
                'oomguarpages_l' => $VPSID[$a][43],
                'oomguarpages_f' => $VPSID[$a][44],
                'numtcpsock' => $VPSID[$a][45],
                'numtcpsock_m' => $VPSID[$a][46],
                'numtcpsock_b' => $VPSID[$a][47],
                'numtcpsock_l' => $VPSID[$a][48],
                'numtcpsock_f' => $VPSID[$a][49],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'numflock' => $VPSID[$a][50],
                'numflock_m' => $VPSID[$a][51],
                'numflock_b' => $VPSID[$a][52],
                'numflock_l' => $VPSID[$a][53],
                'numflock_f' => $VPSID[$a][54],
                'numpty' => $VPSID[$a][55],
                'numpty_m' => $VPSID[$a][56],
                'numpty_b' => $VPSID[$a][57],
                'numpty_l' => $VPSID[$a][58],
                'numpty_f' => $VPSID[$a][59],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'numsiginfo' => $VPSID[$a][60],
                'numsiginfo_m' => $VPSID[$a][61],
                'numsiginfo_b' => $VPSID[$a][62],
                'numsiginfo_l' => $VPSID[$a][63],
                'numsiginfo_f' => $VPSID[$a][64],
                'tcpsndbuf' => $VPSID[$a][65],
                'tcpsndbuf_m' => $VPSID[$a][66],
                'tcpsndbuf_b' => $VPSID[$a][67],
                'tcpsndbuf_l' => $VPSID[$a][68],
                'tcpsndbuf_f' => $VPSID[$a][69],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'tcprcvbuf' => $VPSID[$a][70],
                'tcprcvbuf_m' => $VPSID[$a][71],
                'tcprcvbuf_b' => $VPSID[$a][72],
                'tcprcvbuf_l' => $VPSID[$a][73],
                'tcprcvbuf_f' => $VPSID[$a][74],
                'othersockbuf' => $VPSID[$a][75],
                'othersockbuf_m' => $VPSID[$a][76],
                'othersockbuf_b' => $VPSID[$a][77],
                'othersockbuf_l' => $VPSID[$a][78],
                'othersockbuf_f' => $VPSID[$a][79],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'dgramrcvbuf' => $VPSID[$a][80],
                'dgramrcvbuf_m' => $VPSID[$a][81],
                'dgramrcvbuf_b' => $VPSID[$a][82],
                'dgramrcvbuf_l' => $VPSID[$a][83],
                'dgramrcvbuf_f' => $VPSID[$a][84],
                'numothersock' => $VPSID[$a][85],
                'numothersock_m' => $VPSID[$a][86],
                'numothersock_b' => $VPSID[$a][87],
                'numothersock_l' => $VPSID[$a][88],
                'numothersock_f' => $VPSID[$a][89],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'dcachesize' => $VPSID[$a][90],
                'dcachesize_m' => $VPSID[$a][91],
                'dcachesize_b' => $VPSID[$a][92],
                'dcachesize_l' => $VPSID[$a][93],
                'dcachesize_f' => $VPSID[$a][94],
                'numfile' => $VPSID[$a][95],
                'numfile_m' => $VPSID[$a][96],
                'numfile_b' => $VPSID[$a][97],
                'numfile_l' => $VPSID[$a][98],
                'numfile_f' => $VPSID[$a][99],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'numiptent' => $VPSID[$a][100],
                'numiptent_m' => $VPSID[$a][101],
                'numiptent_b' => $VPSID[$a][102],
                'numiptent_l' => $VPSID[$a][103],
                'numiptent_f' => $VPSID[$a][104],
                'diskspace' => $VPSID[$a][105],
                'diskspace_s' => $VPSID[$a][106],
                'diskspace_h' => $VPSID[$a][107],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'diskinodes' => $VPSID[$a][108],
                'diskinodes_s' => $VPSID[$a][109],
                'diskinodes_h' => $VPSID[$a][110],
                'laverage' => $VPSID[$a][111],
                'cpulimit' => $VPSID[$a][112],
                'cpuunits' => $VPSID[$a][113],
                'timestamp' => time()
                });

		if (!$VPSID[$currentvpsid][114]) { $VPSID[$currentvpsid][114] = "Yes" ; }
		if (!$VPSID[$currentvpsid][115]) { $VPSID[$currentvpsid][115] = '/vz/root/$VEID' ; }
		if (!$VPSID[$currentvpsid][116]) { $VPSID[$currentvpsid][116] = '/vz/private/$VEID' ; }

                ($ok) = $cce->set($sys_oid, '',{        # beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'ONBOOT' => $VPSID[$currentvpsid][114],
                'VE_ROOT' => $VPSID[$currentvpsid][115],
                'VE_PRIVATE' => $VPSID[$currentvpsid][116],
                'failcnt' => '0',
                'failcnt_lastevent' => time(),
                'failcnt_general' => '0',
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'OSTEMPLATE' => $VPSID[$currentvpsid][117],
                'ORIGIN_SAMPLE' => $VPSID[$currentvpsid][118],
                'NAMESERVER' => $VPSID[$currentvpsid][119],
                'QUOTATIME' => $VPSID[$currentvpsid][120],
                'DISK_QUOTA' => $VPSID[$currentvpsid][121],
                'QUOTAUGIDLIMIT' => $VPSID[$currentvpsid][122],
                'timestamp' => time()
                });

                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''

                'volume' => '/vz',
                'basedir' => 'private',
                #'suspend' => '0',  			# Not yet implemented.
                #'name' => 'admin', 			# Not written by the constructor. GUI handles this value.
                'timestamp' => time()
                });
	}

}


# Validate the settings before we pass them on to CCE:
sub validate {

    # ip:
    if (($VPSID[$a][1] == 0) && ($VPSID[$a][2] eq "running") ||
	($VPSID[$a][1] == 0) && ($VPSID[$a][2] eq "stopped") ||
	($VPSID[$a][1] == 0) && ($VPSID[$a][2] eq "mounted")) {

	# If we arrive at this point, then the entire vzlist maxtrix is shifted left from the 
	# 2nd column onwards. This may happen on new VPS which don't have an IP or hostname set yet. 
	# Means that all the data that we have gathered is junk. How to deal with this?
	# We have the vpsid, we have the tools (vzctl), so we set it manually and start over:
	$bad_info_detected++;
	system("/usr/sbin/vzctl set $currentvpsid --ipadd 127.0.0.1 --save");
    }

    if ($VPSID[$a][1] == 0) {
	$VPSID[$a][1] = "127.0.0.1";
    }
    # hostname:
    if ((!$VPSID[$a][2]) || ($VPSID[$a][2] eq "-")) {
	$VPSID[$a][2] = "localhost.localdomain";
    }
    # ostemplate:
    if (!$VPSID[$a][117]) {
	$VPSID[$a][117] = 'unknown';
    }

    ## If a VPS is stopped, then a LOT of values gathered from a VPS will be blanks, represented by a '-'. Which is an invalid
    ## character as far as our CCE-Schema is concerned. So we need to replace that with a '0'. But we cannot do that globally,
    ## as a VPS domain or hostname may also have a '-' in it. So we do that for each value independently:

    if ($VPSID[$a][3] ne "running") {
        $VPSID[$a][5] = "0";
        $VPSID[$a][10] = "0";
        $VPSID[$a][15] = "0";
        $VPSID[$a][20] = "0";
        $VPSID[$a][25] = "0";
        $VPSID[$a][30] = "0";
        $VPSID[$a][35] = "0";
        $VPSID[$a][40] = "0";
        $VPSID[$a][45] = "0";
        $VPSID[$a][50] = "0";
        $VPSID[$a][55] = "0";
        $VPSID[$a][60] = "0";
        $VPSID[$a][65] = "0";
        $VPSID[$a][70] = "0";
        $VPSID[$a][75] = "0";
        $VPSID[$a][80] = "0";
        $VPSID[$a][85] = "0";
        $VPSID[$a][90] = "0";
        $VPSID[$a][95] = "0";
        $VPSID[$a][100] = "0";
        $VPSID[$a][105] = "0";
        $VPSID[$a][108] = "0";
        $VPSID[$a][111] = "0";
        $VPSID[$a][123] = "0";
        $VPSID[$a][124] = "0";
    }
}

# Update or populate CCE with the CPU_POWER and CURRENT_CPU (usage) of the master node:
sub cce_update_cpu {

	# This is where we actually populate CCE with the gathered info:
        @oids = $cce->find('VserverMasterNode');
        if ($#oids < 0) {
                #print "Object not yet in CCE. Creating new one.\n";
                ($ok) = $cce->create('VserverMasterNode', {
                'CURRENT_CPU' => $CURRENT_CPU,
                'NODE_CPU' => $NODE_CPU
                });
        }
        else {
                #print "Object already present in CCE. Updating it.\n";
                # find the system object
                ($sys_oid) = $cce->find('VserverMasterNode');
                ($ok, $sys) = $cce->get($sys_oid);
                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'CURRENT_CPU' => $CURRENT_CPU,
                'NODE_CPU' => $NODE_CPU
                });
	}
}

# Pull the existing sample VPS config files into CCE:
sub sampleconfigs {
    system ("rm -f /tmp/sampleconf");
    system("ls -k1 $vzcfgdir*.conf-sample | cut -d \/ -f5 |sed 's/ve-//'g | sed 's/.conf-sample//'g > /tmp/sampleconf");

    # Does the config file exist?
    $cfile = "/tmp/sampleconf";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

        # Find all previous VserverConfigSamples entries and destroy them:
        @oldsamples = $cce->findx('VserverConfigSamples', { 'nusol' => 'nusol' });
        for $entry (@oldsamples) {
            ($ok) = $cce->destroy($entry);
        }

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    # Populate CCE:
            ($ok) = $cce->create('VserverConfigSamples', {
            	    'nusol' => 'nusol',
            	    'ConfigShortName' => $line,
            	    'ConfigFullName' => 've-' . $line . '.conf-sample'
            	    });
        }
    }
    system ("rm -f /tmp/sampleconf");
}

# Pull the existing OS Templates into CCE:
sub ostemplates {
    if (!-d "/vz/template") {
	system("/bin/mkdir /vz/template");
    }
    if (!-d "/vz/template/cache") {
        system("/bin/mkdir /vz/template/cache");
    }
    if (!-f "/etc/vz/vz.conf") {

        if (!-d "/vz/cluster/") {
            system("/bin/mkdir /vz/cluster/");
        }
        if (!-d "/vz/cluster/etc") {
            system("/bin/mkdir /vz/cluster/etc");
        }
        if (!-d "/vz/cluster/etc/vz") {
            system("/bin/mkdir /vz/cluster/etc/vz");
        }
    
        if (!-d "/vz/cluster/etc/sysconfig") {
            system("/bin/mkdir /vz/cluster/etc/sysconfig");
        }
        if (!-d "/vz/cluster/etc/sysconfig/vz-scripts") {
            system("/bin/mkdir /vz/cluster/etc/sysconfig/vz-scripts");
        }
    }
    system ("rm -f /tmp/ostemplates");
    #system("ls -k1 /vz/template/cache/*.tar.gz |sed 's/\.tar\.gz//'g |sed 's/\/vz\/template\/cache\///'g > /tmp/ostemplates");
    system("ls -k1 /vz/template/cache/*.tar.gz |sed 's/\.tar\.gz//'g | cut -d / -f 5 > /tmp/ostemplates");

    # Does the dump file exist?
    $cfile = "/tmp/ostemplates";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

        # Find all previous VserverOStemplates entries and destroy them:
        @oldsamples = $cce->findx('VserverOStemplates', { 'OSTnusol' => 'nusol' });
        for $entry (@oldsamples) {
            ($ok) = $cce->destroy($entry);
        }

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    # Populate CCE:
            ($ok) = $cce->create('VserverOStemplates', {
            	    'OSTnusol' => 'nusol',
            	    'OStemplateShortName' => $line,
            	    'OStemplateFullName' => $line . '.tar.gz'
            	    });
        }
    }
    system ("rm -f /tmp/ostemplates");
}

# Handle IP address allocation:

sub ip_alloc {

    # Find existing vpsIPalloc objects:
    @old_alloc = $cce->findx('vpsIPalloc', {'vpsid' => $currentvpsid});
    if ($#old_alloc == -1) {
        # Nothing found in CCE
        if (@raw_ip_list) {

	    # But we found extra IPs in the config file
	    for $alloc_entry (@old_alloc) {
		# Destroy old allocation entries:
		($ok) = $cce->destroy($alloc_entry);
	    }

	    # Write new ones:
	    foreach $jummy_ip (@raw_ip_list) {
		if ($jummy_ip ne "") {
		    ($ok) = $cce->create('vpsIPalloc', {
        		'vpsid' => $currentvpsid,
               		'min' => $jummy_ip,
               		'creation_time' => time()
               	    });
		}
	    }
        }
    }
}

$cce->bye('SUCCESS');
exit(0);

# Legend of Matrix columns:

# 0 = vpsid
# 1 = ip
# 2 = hostname
# 3 = status
# 4 = numproc
# 5 = kmemsize
# 6 = kmemsize.m
# 7 = kmemsize.b
# 8 = kmemsize.l
# 9 = kmemsize.f
# 10 = lockedpages
# 11 = lockedpages.m
# 12 = lockedpages.b
# 13 = lockedpages.l
# 14 = lockedpages.f
# 15 = privvmpages
# 16 = privvmpages.m
# 17 = privvmpages.b
# 18 = privvmpages.l
# 19 = privvmpages.f
# 20 = shmpages
# 21 = shmpages.m
# 22 = shmpages.b
# 23 = shmpages.l
# 24 = shmpages.f
# 25 = numproc
# 26 = numproc.m
# 27 = numproc.b
# 28 = numproc.l
# 29 = numproc.f
# 30 = physpages
# 31 = physpages.m
# 32 = physpages.b
# 33 = physpages.l
# 34 = physpages.f
# 35 = vmguarpages
# 36 = vmguarpages.m
# 37 = vmguarpages.b
# 38 = vmguarpages.l
# 39 = vmguarpages.f
# 40 = oomguarpages
# 41 = oomguarpages.m
# 42 = oomguarpages.b
# 43 = oomguarpages.l
# 44 = oomguarpages.f
# 45 = numtcpsock
# 46 = numtcpsock.m
# 47 = numtcpsock.b
# 48 = numtcpsock.l
# 49 = numtcpsock.f
# 50 = numflock
# 51 = numflock.m
# 52 = numflock.b
# 53 = numflock.l
# 54 = numflock.f
# 55 = numpty
# 56 = numpty.m
# 57 = numpty.b
# 58 = numpty.l
# 59 = numpty.f
# 60 = numsiginfo
# 61 = numsiginfo.m
# 62 = numsiginfo.b
# 63 = numsiginfo.l
# 64 = numsiginfo.f
# 65 = tcpsndbuf
# 66 = tcpsndbuf.m
# 67 = tcpsndbuf.b
# 68 = tcpsndbuf.l
# 69 = tcpsndbuf.f
# 70 = tcprcvbuf
# 71 = tcprcvbuf.m
# 72 = tcprcvbuf.b
# 73 = tcprcvbuf.l
# 74 = tcprcvbuf.f
# 75 = othersockbuf
# 76 = othersockbuf.m
# 77 = othersockbuf.b
# 78 = othersockbuf.l
# 79 = othersockbuf.f
# 80 = dgramrcvbuf
# 81 = dgramrcvbuf.m
# 82 = dgramrcvbuf.b
# 83 = dgramrcvbuf.l
# 84 = dgramrcvbuf.f
# 85 = numothersock
# 86 = numothersock.m
# 87 = numothersock.b
# 88 = numothersock.l
# 89 = numothersock.f
# 90 = dcachesize
# 91 = dcachesize.m
# 92 = dcachesize.b
# 93 = dcachesize.l
# 94 = dcachesize.f
# 95 = numfile
# 96 = numfile.m
# 97 = numfile.b
# 98 = numfile.l
# 99 = numfile.f
# 100 = numiptent
# 101 = numiptent.m
# 102 = numiptent.b
# 103 = numiptent.l
# 104 = numiptent.f
# 105 = diskspace
# 106 = diskspace.s
# 107 = diskspace.h
# 108 = diskinodes
# 109 = diskinodes.s
# 110 = diskinodes.h
# 111 = laverage
# 112 = cpulimit
# 113 = cpuunits

### From config file:
# 114 = onboot
# 115 = ve_root
# 116 = ve_private
# 117 = ostemplate
# 118 = origin_sample
# 119 = nameserver
# 120 = quotatime
# 121 = disk_quota
# 122 = quotaugidlimit
# 123 = avnumproc_b
# 124 = avnumproc_l
# 125 = ip_list (IP address allocation)

